Index: lemon/lp_base.h
===================================================================
--- lemon/lp_base.h	(revision 1493)
+++ lemon/lp_base.h	(revision 1508)
@@ -152,5 +152,5 @@
 	  UNKNOWN = 4
       };
-      
+
     ///The floating point type used by the solver
     typedef double Value;
Index: lemon/lp_cplex.cc
===================================================================
--- lemon/lp_cplex.cc	(revision 1473)
+++ lemon/lp_cplex.cc	(revision 1508)
@@ -46,5 +46,5 @@
     //object and copy all the problem data from an existing problem 
     //object to it. Solution and starting information is not copied.
-    newlp->lp = CPXcloneprob (env, lp, &status);
+    newlp->lp = CPXcloneprob(env, lp, &status);
     return *newlp;
   }
@@ -52,9 +52,9 @@
   int LpCplex::_addCol()
   {
-    int i = CPXgetnumcols (env, lp);
+    int i = CPXgetnumcols(env, lp);
     Value lb[1],ub[1];
     lb[0]=-INF;//-CPX_INFBOUND;
     ub[0]=INF;//CPX_INFBOUND;
-    status = CPXnewcols (env, lp, 1, NULL, lb, ub, NULL, NULL);
+    status = CPXnewcols(env, lp, 1, NULL, lb, ub, NULL, NULL);
     return i;
   }
@@ -68,6 +68,6 @@
     Value rhs[1];
     rhs[0]=INF;
-    int i = CPXgetnumrows (env, lp);
-    status = CPXnewrows (env, lp, 1, rhs, sense, NULL, NULL);
+    int i = CPXgetnumrows(env, lp);
+    status = CPXnewrows(env, lp, 1, rhs, sense, NULL, NULL);
     return i;
   }
@@ -75,9 +75,9 @@
 
   void LpCplex::_eraseCol(int i) {
-    CPXdelcols (env, lp, i, i);
+    CPXdelcols(env, lp, i, i);
   }
   
   void LpCplex::_eraseRow(int i) {
-    CPXdelrows (env, lp, i, i);
+    CPXdelrows(env, lp, i, i);
   }
 
@@ -120,5 +120,5 @@
   void LpCplex::_setCoeff(int row, int col, Value value) 
   {
-    CPXchgcoef (env, lp, row, col, value);
+    CPXchgcoef(env, lp, row, col, value);
   }
 
@@ -131,5 +131,5 @@
     Value bd[1];
     bd[0]=value;
-    status = CPXchgbds (env, lp, 1, indices, lu, bd);
+    status = CPXchgbds(env, lp, 1, indices, lu, bd);
  
   }
@@ -143,5 +143,5 @@
     Value bd[1];
     bd[0]=value;
-    status = CPXchgbds (env, lp, 1, indices, lu, bd);
+    status = CPXchgbds(env, lp, 1, indices, lu, bd);
   }
 
@@ -161,6 +161,6 @@
     if (lb==-INF){
       sense[0]='L';
-      CPXchgsense (env, lp, cnt, indices, sense);
-      CPXchgcoef (env, lp, i, -1, ub);
+      CPXchgsense(env, lp, cnt, indices, sense);
+      CPXchgcoef(env, lp, i, -1, ub);
       
     }
@@ -168,18 +168,18 @@
       if (ub==INF){
 	sense[0]='G';
-	CPXchgsense (env, lp, cnt, indices, sense);
-	CPXchgcoef (env, lp, i, -1, lb);
+	CPXchgsense(env, lp, cnt, indices, sense);
+	CPXchgcoef(env, lp, i, -1, lb);
       }
       else{
 	if (lb == ub){
 	  sense[0]='E';
-	  CPXchgsense (env, lp, cnt, indices, sense);
-	  CPXchgcoef (env, lp, i, -1, lb);
+	  CPXchgsense(env, lp, cnt, indices, sense);
+	  CPXchgcoef(env, lp, i, -1, lb);
 	}
 	else{
 	  sense[0]='R';
-	  CPXchgsense (env, lp, cnt, indices, sense);
-	  CPXchgcoef (env, lp, i, -1, lb);
-	  CPXchgcoef (env, lp, i, -2, ub-lb);	  
+	  CPXchgsense(env, lp, cnt, indices, sense);
+	  CPXchgcoef(env, lp, i, -1, lb);
+	  CPXchgcoef(env, lp, i, -2, ub-lb);	  
 	}
       }
@@ -198,7 +198,7 @@
 // //     //type of the problem
 // //     char sense[1];
-// //     status = CPXgetsense (env, lp, sense, i, i);
+// //     status = CPXgetsense(env, lp, sense, i, i);
 // //     Value rhs[1];
-// //     status = CPXgetrhs (env, lp, rhs, i, i);
+// //     status = CPXgetrhs(env, lp, rhs, i, i);
 
 // //     switch (sense[0]) {
@@ -215,16 +215,16 @@
 // //     }
 
-// //     status = CPXchgcoef (env, lp, i, -2, value_rng);
+// //     status = CPXchgcoef(env, lp, i, -2, value_rng);
 //   }
   
   void LpCplex::_setObjCoeff(int i, Value obj_coef)
   {
-    CPXchgcoef (env, lp, -1, i, obj_coef);
+    CPXchgcoef(env, lp, -1, i, obj_coef);
   }
 
   void LpCplex::_clearObj()
   {
-    for (int i=0;i< CPXgetnumcols (env, lp);++i){
-      CPXchgcoef (env, lp, -1, i, 0);
+    for (int i=0;i< CPXgetnumcols(env, lp);++i){
+      CPXchgcoef(env, lp, -1, i, 0);
     }
     
@@ -242,8 +242,8 @@
   {
     //CPX_PARAM_LPMETHOD 
-    status = CPXlpopt (env, lp);
+    status = CPXlpopt(env, lp);
     if (status == 0){
       //We want to exclude some cases
-      switch (CPXgetstat (env, lp)){
+      switch (CPXgetstat(env, lp)){
       case CPX_OBJ_LIM:
       case CPX_IT_LIM_FEAS:
@@ -264,5 +264,5 @@
   {
     Value x;
-    CPXgetx (env, lp, &x, i, i);
+    CPXgetx(env, lp, &x, i, i);
     return x;
   }
@@ -272,5 +272,7 @@
     Value objval;
     //method = CPXgetmethod (env, lp);
-    status = CPXgetobjval (env, lp, &objval);
+    //printf("CPXgetprobtype %d \n",CPXgetprobtype(env,lp));
+    status = CPXgetobjval(env, lp, &objval);
+    //printf("Objective value: %g \n",objval);
     return objval;
   }
@@ -330,5 +332,6 @@
   LpCplex::SolutionStatus LpCplex::_getPrimalStatus()
   {
-    int stat = CPXgetstat (env, lp);
+    int stat = CPXgetstat(env, lp);
+    //printf("A primal status: %d, CPX_OPTIMAL=%d \n",stat,CPX_OPTIMAL);
     switch (stat) {
     case 0:
@@ -380,5 +383,5 @@
   LpCplex::SolutionStatus LpCplex::_getDualStatus()
   {
-    int stat = CPXgetstat (env, lp);
+    int stat = CPXgetstat(env, lp);
     switch (stat) {
     case 0:
@@ -396,5 +399,5 @@
   LpCplex::ProblemTypes LpCplex::_getProblemType()
   {
-    int stat = CPXgetstat (env, lp);
+    int stat = CPXgetstat(env, lp);
     switch (stat) {
     case CPX_OPTIMAL://Optimal
@@ -415,9 +418,9 @@
   void LpCplex::_setMax()
   {
-    CPXchgobjsen (env, lp, CPX_MAX);
+    CPXchgobjsen(env, lp, CPX_MAX);
    }
   void LpCplex::_setMin()
   {
-    CPXchgobjsen (env, lp, CPX_MIN);
+    CPXchgobjsen(env, lp, CPX_MIN);
    }
   
Index: lemon/lp_skeleton.h
===================================================================
--- lemon/lp_skeleton.h	(revision 1460)
+++ lemon/lp_skeleton.h	(revision 1508)
@@ -23,5 +23,5 @@
 ///\brief A skeleton file to implement LP solver interfaces
 namespace lemon {
-  
+
   ///A skeleton class to implement LP solver interfaces
   class LpSkeleton :public LpSolverBase {
Index: test/lp_test.cc
===================================================================
--- test/lp_test.cc	(revision 1493)
+++ test/lp_test.cc	(revision 1508)
@@ -18,4 +18,7 @@
 void lpTest(LpSolverBase & lp)
 {
+
+
+
   typedef LpSolverBase LP;
 
@@ -23,4 +26,6 @@
   //  for(int i=0;i<10;i++) x.push_back(lp.addCol());
   lp.addColSet(x);
+
+#ifndef GYORSITAS
 
   std::vector<LP::Col> y(10);
@@ -175,5 +180,5 @@
   }
   
-
+#endif
 }
 
@@ -241,6 +246,7 @@
 
 #ifdef HAVE_CPLEX
-//  LpCplex lp_cplex;
-//  lpTest(lp_cplex);
+  LpCplex lp_cplex;
+  lpTest(lp_cplex);
+  aTest(lp_cplex);
 #endif
 