Index: lemon/base.cc
===================================================================
--- lemon/base.cc	(revision 357)
+++ lemon/base.cc	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/bits/default_map.h
===================================================================
--- lemon/bits/default_map.h	(revision 395)
+++ lemon/bits/default_map.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/bits/map_extender.h
===================================================================
--- lemon/bits/map_extender.h	(revision 406)
+++ lemon/bits/map_extender.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/bits/path_dump.h
===================================================================
--- lemon/bits/path_dump.h	(revision 414)
+++ lemon/bits/path_dump.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/bits/windows.cc
===================================================================
--- lemon/bits/windows.cc	(revision 370)
+++ lemon/bits/windows.cc	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2009
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -97,5 +97,5 @@
       GetSystemTime(&time);
       char buf1[11], buf2[9], buf3[5];
-	  if (GetDateFormat(MY_LOCALE, 0, &time,
+          if (GetDateFormat(MY_LOCALE, 0, &time,
                         ("ddd MMM dd"), buf1, 11) &&
           GetTimeFormat(MY_LOCALE, 0, &time,
Index: lemon/core.h
===================================================================
--- lemon/core.h	(revision 416)
+++ lemon/core.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/dfs.h
===================================================================
--- lemon/dfs.h	(revision 421)
+++ lemon/dfs.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/graph_to_eps.h
===================================================================
--- lemon/graph_to_eps.h	(revision 409)
+++ lemon/graph_to_eps.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/lgf_reader.h
===================================================================
--- lemon/lgf_reader.h	(revision 423)
+++ lemon/lgf_reader.h	(revision 427)
@@ -392,5 +392,5 @@
 
   template <typename Digraph>
-  DigraphReader<Digraph> digraphReader(Digraph& digraph, 
+  DigraphReader<Digraph> digraphReader(Digraph& digraph,
                                        std::istream& is = std::cin);
   template <typename Digraph>
@@ -564,5 +564,5 @@
     friend DigraphReader<DGR> digraphReader(DGR& digraph, std::istream& is);
     template <typename DGR>
-    friend DigraphReader<DGR> digraphReader(DGR& digraph, 
+    friend DigraphReader<DGR> digraphReader(DGR& digraph,
                                             const std::string& fn);
     template <typename DGR>
@@ -1230,7 +1230,7 @@
   template <typename Graph>
   class GraphReader;
- 
+
   template <typename Graph>
-  GraphReader<Graph> graphReader(Graph& graph, 
+  GraphReader<Graph> graphReader(Graph& graph,
                                  std::istream& is = std::cin);
   template <typename Graph>
@@ -1367,5 +1367,5 @@
     friend GraphReader<GR> graphReader(GR& graph, std::istream& is);
     template <typename GR>
-    friend GraphReader<GR> graphReader(GR& graph, const std::string& fn); 
+    friend GraphReader<GR> graphReader(GR& graph, const std::string& fn);
     template <typename GR>
     friend GraphReader<GR> graphReader(GR& graph, const char *fn);
Index: lemon/lgf_writer.h
===================================================================
--- lemon/lgf_writer.h	(revision 374)
+++ lemon/lgf_writer.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -507,5 +507,5 @@
 
     template <typename DGR>
-    friend DigraphWriter<DGR> digraphWriter(const DGR& digraph, 
+    friend DigraphWriter<DGR> digraphWriter(const DGR& digraph,
                                             std::ostream& os);
     template <typename DGR>
@@ -1083,5 +1083,5 @@
     friend GraphWriter<GR> graphWriter(const GR& graph,
                                        const char *fn);
-    
+
     GraphWriter(GraphWriter& other)
       : _os(other._os), local_os(other.local_os), _graph(other._graph),
Index: lemon/list_graph.h
===================================================================
--- lemon/list_graph.h	(revision 317)
+++ lemon/list_graph.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -841,6 +841,6 @@
 
     public:
-      operator Edge() const { 
-        return id != -1 ? edgeFromId(id / 2) : INVALID; 
+      operator Edge() const {
+        return id != -1 ? edgeFromId(id / 2) : INVALID;
       }
 
Index: lemon/path.h
===================================================================
--- lemon/path.h	(revision 404)
+++ lemon/path.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -967,5 +967,5 @@
     };
 
-    
+
     template <typename From, typename To,
               bool revEnable = RevPathTagIndicator<From>::value>
@@ -973,5 +973,5 @@
       static void copy(const From& from, To& to) {
         PathCopySelectorForward<From, To>::copy(from, to);
-      }      
+      }
     };
 
@@ -980,5 +980,5 @@
       static void copy(const From& from, To& to) {
         PathCopySelectorBackward<From, To>::copy(from, to);
-      }      
+      }
     };
 
Index: lemon/random.h
===================================================================
--- lemon/random.h	(revision 374)
+++ lemon/random.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/smart_graph.h
===================================================================
--- lemon/smart_graph.h	(revision 337)
+++ lemon/smart_graph.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -467,6 +467,6 @@
 
     public:
-      operator Edge() const { 
-        return _id != -1 ? edgeFromId(_id / 2) : INVALID; 
+      operator Edge() const {
+        return _id != -1 ? edgeFromId(_id / 2) : INVALID;
       }
 
Index: lemon/time_measure.h
===================================================================
--- lemon/time_measure.h	(revision 383)
+++ lemon/time_measure.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/tolerance.h
===================================================================
--- lemon/tolerance.h	(revision 373)
+++ lemon/tolerance.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/unionfind.h
===================================================================
--- lemon/unionfind.h	(revision 408)
+++ lemon/unionfind.h	(revision 427)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2011
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -1190,5 +1190,5 @@
               popLeft(nodes[jd].next);
               pushRight(jd, ld);
-              if (less(ld, nodes[jd].left) || 
+              if (less(ld, nodes[jd].left) ||
                   nodes[ld].item == nodes[pd].item) {
                 nodes[jd].item = nodes[ld].item;