Index: lemon/bits/graph_adaptor_extender.h
===================================================================
--- lemon/bits/graph_adaptor_extender.h	(revision 430)
+++ lemon/bits/graph_adaptor_extender.h	(revision 432)
@@ -1,5 +1,5 @@
-/* -*- C++ -*-
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
  *
- * This file is a part of LEMON, a generic C++ optimization library
+ * This file is a part of LEMON, a generic C++ optimization library.
  *
  * Copyright (C) 2003-2008
@@ -25,13 +25,6 @@
 #include <lemon/bits/default_map.h>
 
-
-///\ingroup digraphbits
-///\file
-///\brief Extenders for the digraph adaptor types
 namespace lemon {
 
-  /// \ingroup digraphbits
-  ///
-  /// \brief Extender for the DigraphAdaptors
   template <typename _Digraph>
   class DigraphAdaptorExtender : public _Digraph {
@@ -65,12 +58,12 @@
     Node oppositeNode(const Node &n, const Arc &e) const {
       if (n == Parent::source(e))
-	return Parent::target(e);
+        return Parent::target(e);
       else if(n==Parent::target(e))
-	return Parent::source(e);
+        return Parent::source(e);
       else
-	return INVALID;
-    }
-
-    class NodeIt : public Node { 
+        return INVALID;
+    }
+
+    class NodeIt : public Node {
       const Adaptor* _adaptor;
     public:
@@ -81,19 +74,19 @@
 
       explicit NodeIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Node&>(*this));
-      }
-
-      NodeIt(const Adaptor& adaptor, const Node& node) 
-	: Node(node), _adaptor(&adaptor) {}
-
-      NodeIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class ArcIt : public Arc { 
+        _adaptor->first(static_cast<Node&>(*this));
+      }
+
+      NodeIt(const Adaptor& adaptor, const Node& node)
+        : Node(node), _adaptor(&adaptor) {}
+
+      NodeIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class ArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -104,19 +97,19 @@
 
       explicit ArcIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Arc&>(*this));
-      }
-
-      ArcIt(const Adaptor& adaptor, const Arc& e) : 
-	Arc(e), _adaptor(&adaptor) { }
-
-      ArcIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class OutArcIt : public Arc { 
+        _adaptor->first(static_cast<Arc&>(*this));
+      }
+
+      ArcIt(const Adaptor& adaptor, const Arc& e) :
+        Arc(e), _adaptor(&adaptor) { }
+
+      ArcIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class OutArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -126,21 +119,21 @@
       OutArcIt(Invalid i) : Arc(i) { }
 
-      OutArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstOut(*this, node);
-      }
-
-      OutArcIt(const Adaptor& adaptor, const Arc& arc) 
-	: Arc(arc), _adaptor(&adaptor) {}
-
-      OutArcIt& operator++() { 
-	_adaptor->nextOut(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class InArcIt : public Arc { 
+      OutArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstOut(*this, node);
+      }
+
+      OutArcIt(const Adaptor& adaptor, const Arc& arc)
+        : Arc(arc), _adaptor(&adaptor) {}
+
+      OutArcIt& operator++() {
+        _adaptor->nextOut(*this);
+        return *this;
+      }
+
+    };
+
+
+    class InArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -150,43 +143,29 @@
       InArcIt(Invalid i) : Arc(i) { }
 
-      InArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstIn(*this, node);
-      }
-
-      InArcIt(const Adaptor& adaptor, const Arc& arc) : 
-	Arc(arc), _adaptor(&adaptor) {}
-
-      InArcIt& operator++() { 
-	_adaptor->nextIn(*this);
-	return *this; 
-      }
-
-    };
-
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the source in this case) of the iterator
+      InArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstIn(*this, node);
+      }
+
+      InArcIt(const Adaptor& adaptor, const Arc& arc) :
+        Arc(arc), _adaptor(&adaptor) {}
+
+      InArcIt& operator++() {
+        _adaptor->nextIn(*this);
+        return *this;
+      }
+
+    };
+
     Node baseNode(const OutArcIt &e) const {
       return Parent::source(e);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the target in this case) of the
-    /// iterator
     Node runningNode(const OutArcIt &e) const {
       return Parent::target(e);
     }
 
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the target in this case) of the iterator
     Node baseNode(const InArcIt &e) const {
       return Parent::target(e);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the source in this case) of the
-    /// iterator
     Node runningNode(const InArcIt &e) const {
       return Parent::source(e);
@@ -199,8 +178,8 @@
   ///
   /// \brief Extender for the GraphAdaptors
-  template <typename _Graph> 
+  template <typename _Graph>
   class GraphAdaptorExtender : public _Graph {
   public:
-    
+
     typedef _Graph Parent;
     typedef _Graph Graph;
@@ -211,5 +190,5 @@
     typedef typename Parent::Edge Edge;
 
-    // Graph extension    
+    // Graph extension
 
     int maxId(Node) const {
@@ -239,9 +218,9 @@
     Node oppositeNode(const Node &n, const Edge &e) const {
       if( n == Parent::u(e))
-	return Parent::v(e);
+        return Parent::v(e);
       else if( n == Parent::v(e))
-	return Parent::u(e);
+        return Parent::u(e);
       else
-	return INVALID;
+        return INVALID;
     }
 
@@ -256,5 +235,5 @@
 
 
-    class NodeIt : public Node { 
+    class NodeIt : public Node {
       const Adaptor* _adaptor;
     public:
@@ -265,19 +244,19 @@
 
       explicit NodeIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Node&>(*this));
-      }
-
-      NodeIt(const Adaptor& adaptor, const Node& node) 
-	: Node(node), _adaptor(&adaptor) {}
-
-      NodeIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class ArcIt : public Arc { 
+        _adaptor->first(static_cast<Node&>(*this));
+      }
+
+      NodeIt(const Adaptor& adaptor, const Node& node)
+        : Node(node), _adaptor(&adaptor) {}
+
+      NodeIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class ArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -288,19 +267,19 @@
 
       explicit ArcIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Arc&>(*this));
-      }
-
-      ArcIt(const Adaptor& adaptor, const Arc& e) : 
-	Arc(e), _adaptor(&adaptor) { }
-
-      ArcIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class OutArcIt : public Arc { 
+        _adaptor->first(static_cast<Arc&>(*this));
+      }
+
+      ArcIt(const Adaptor& adaptor, const Arc& e) :
+        Arc(e), _adaptor(&adaptor) { }
+
+      ArcIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class OutArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -310,21 +289,21 @@
       OutArcIt(Invalid i) : Arc(i) { }
 
-      OutArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstOut(*this, node);
-      }
-
-      OutArcIt(const Adaptor& adaptor, const Arc& arc) 
-	: Arc(arc), _adaptor(&adaptor) {}
-
-      OutArcIt& operator++() { 
-	_adaptor->nextOut(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class InArcIt : public Arc { 
+      OutArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstOut(*this, node);
+      }
+
+      OutArcIt(const Adaptor& adaptor, const Arc& arc)
+        : Arc(arc), _adaptor(&adaptor) {}
+
+      OutArcIt& operator++() {
+        _adaptor->nextOut(*this);
+        return *this;
+      }
+
+    };
+
+
+    class InArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -334,20 +313,20 @@
       InArcIt(Invalid i) : Arc(i) { }
 
-      InArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstIn(*this, node);
-      }
-
-      InArcIt(const Adaptor& adaptor, const Arc& arc) : 
-	Arc(arc), _adaptor(&adaptor) {}
-
-      InArcIt& operator++() { 
-	_adaptor->nextIn(*this);
-	return *this; 
-      }
-
-    };
-
-    class EdgeIt : public Parent::Edge { 
+      InArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstIn(*this, node);
+      }
+
+      InArcIt(const Adaptor& adaptor, const Arc& arc) :
+        Arc(arc), _adaptor(&adaptor) {}
+
+      InArcIt& operator++() {
+        _adaptor->nextIn(*this);
+        return *this;
+      }
+
+    };
+
+    class EdgeIt : public Parent::Edge {
       const Adaptor* _adaptor;
     public:
@@ -358,18 +337,18 @@
 
       explicit EdgeIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Edge&>(*this));
-      }
-
-      EdgeIt(const Adaptor& adaptor, const Edge& e) : 
-	Edge(e), _adaptor(&adaptor) { }
-
-      EdgeIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-    class IncEdgeIt : public Edge { 
+        _adaptor->first(static_cast<Edge&>(*this));
+      }
+
+      EdgeIt(const Adaptor& adaptor, const Edge& e) :
+        Edge(e), _adaptor(&adaptor) { }
+
+      EdgeIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+    class IncEdgeIt : public Edge {
       friend class GraphAdaptorExtender;
       const Adaptor* _adaptor;
@@ -382,55 +361,35 @@
 
       IncEdgeIt(const Adaptor& adaptor, const Node &n) : _adaptor(&adaptor) {
-	_adaptor->firstInc(static_cast<Edge&>(*this), direction, n);
+        _adaptor->firstInc(static_cast<Edge&>(*this), direction, n);
       }
 
       IncEdgeIt(const Adaptor& adaptor, const Edge &e, const Node &n)
-	: _adaptor(&adaptor), Edge(e) {
-	direction = (_adaptor->u(e) == n);
+        : _adaptor(&adaptor), Edge(e) {
+        direction = (_adaptor->u(e) == n);
       }
 
       IncEdgeIt& operator++() {
-	_adaptor->nextInc(*this, direction);
-	return *this; 
-      }
-    };
-
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the source in this case) of the iterator
+        _adaptor->nextInc(*this, direction);
+        return *this;
+      }
+    };
+
     Node baseNode(const OutArcIt &a) const {
       return Parent::source(a);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the target in this case) of the
-    /// iterator
     Node runningNode(const OutArcIt &a) const {
       return Parent::target(a);
     }
 
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the target in this case) of the iterator
     Node baseNode(const InArcIt &a) const {
       return Parent::target(a);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the source in this case) of the
-    /// iterator
     Node runningNode(const InArcIt &a) const {
       return Parent::source(a);
     }
 
-    /// Base node of the iterator
-    ///
-    /// Returns the base node of the iterator
     Node baseNode(const IncEdgeIt &e) const {
       return e.direction ? Parent::u(e) : Parent::v(e);
     }
-    /// Running node of the iterator
-    ///
-    /// Returns the running node of the iterator
     Node runningNode(const IncEdgeIt &e) const {
       return e.direction ? Parent::v(e) : Parent::u(e);
Index: lemon/bits/variant.h
===================================================================
--- lemon/bits/variant.h	(revision 430)
+++ lemon/bits/variant.h	(revision 432)
@@ -1,5 +1,5 @@
-/* -*- C++ -*-
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
  *
- * This file is a part of LEMON, a generic C++ optimization library
+ * This file is a part of LEMON, a generic C++ optimization library.
  *
  * Copyright (C) 2003-2008
@@ -28,5 +28,5 @@
 
   namespace _variant_bits {
-  
+
     template <int left, int right>
     struct CTMax {
@@ -87,7 +87,7 @@
       flag = bivariant.flag;
       if (flag) {
-        new(reinterpret_cast<First*>(data)) First(bivariant.first());      
+        new(reinterpret_cast<First*>(data)) First(bivariant.first());
       } else {
-        new(reinterpret_cast<Second*>(data)) Second(bivariant.second());      
+        new(reinterpret_cast<Second*>(data)) Second(bivariant.second());
       }
     }
@@ -107,5 +107,5 @@
       destroy();
       flag = true;
-      new(reinterpret_cast<First*>(data)) First();   
+      new(reinterpret_cast<First*>(data)) First();
       return *this;
     }
@@ -118,5 +118,5 @@
       destroy();
       flag = true;
-      new(reinterpret_cast<First*>(data)) First(f);   
+      new(reinterpret_cast<First*>(data)) First(f);
       return *this;
     }
@@ -129,5 +129,5 @@
       destroy();
       flag = false;
-      new(reinterpret_cast<Second*>(data)) Second();   
+      new(reinterpret_cast<Second*>(data)) Second();
       return *this;
     }
@@ -140,5 +140,5 @@
       destroy();
       flag = false;
-      new(reinterpret_cast<Second*>(data)) Second(s);   
+      new(reinterpret_cast<Second*>(data)) Second(s);
       return *this;
     }
@@ -160,7 +160,7 @@
       flag = bivariant.flag;
       if (flag) {
-        new(reinterpret_cast<First*>(data)) First(bivariant.first());      
+        new(reinterpret_cast<First*>(data)) First(bivariant.first());
       } else {
-        new(reinterpret_cast<Second*>(data)) Second(bivariant.second());      
+        new(reinterpret_cast<Second*>(data)) Second(bivariant.second());
       }
       return *this;
@@ -232,5 +232,5 @@
       }
     }
-    
+
     char data[_variant_bits::CTMax<sizeof(First), sizeof(Second)>::value];
     bool flag;
@@ -238,5 +238,5 @@
 
   namespace _variant_bits {
-    
+
     template <int _idx, typename _TypeMap>
     struct Memory {
@@ -277,6 +277,6 @@
     template <int _idx, typename _TypeMap>
     struct Size {
-      static const int value = 
-      CTMax<sizeof(typename _TypeMap::template Map<_idx>::Type), 
+      static const int value =
+      CTMax<sizeof(typename _TypeMap::template Map<_idx>::Type),
             Size<_idx - 1, _TypeMap>::value>::value;
     };
@@ -284,5 +284,5 @@
     template <typename _TypeMap>
     struct Size<0, _TypeMap> {
-      static const int value = 
+      static const int value =
       sizeof(typename _TypeMap::template Map<0>::Type);
     };
@@ -302,5 +302,5 @@
   /// variant type.
   /// \param _TypeMap This class describes the types of the Variant. The
-  /// _TypeMap::Map<index>::Type should be a valid type for each index 
+  /// _TypeMap::Map<index>::Type should be a valid type for each index
   /// in the range {0, 1, ..., _num - 1}. The \c VariantTypeMap is helper
   /// class to define such type mappings up to 10 types.
@@ -338,5 +338,5 @@
     Variant() {
       flag = 0;
-      new(reinterpret_cast<typename TypeMap::template Map<0>::Type*>(data)) 
+      new(reinterpret_cast<typename TypeMap::template Map<0>::Type*>(data))
         typename TypeMap::template Map<0>::Type();
     }
@@ -379,5 +379,5 @@
       _variant_bits::Memory<num - 1, TypeMap>::destroy(flag, data);
       flag = _idx;
-      new(reinterpret_cast<typename TypeMap::template Map<_idx>::Type*>(data)) 
+      new(reinterpret_cast<typename TypeMap::template Map<_idx>::Type*>(data))
         typename TypeMap::template Map<_idx>::Type();
       return *this;
@@ -392,5 +392,5 @@
       _variant_bits::Memory<num - 1, TypeMap>::destroy(flag, data);
       flag = _idx;
-      new(reinterpret_cast<typename TypeMap::template Map<_idx>::Type*>(data)) 
+      new(reinterpret_cast<typename TypeMap::template Map<_idx>::Type*>(data))
         typename TypeMap::template Map<_idx>::Type(init);
       return *this;
@@ -404,5 +404,5 @@
       LEMON_DEBUG(_idx == flag, "Variant wrong index");
       return *reinterpret_cast<const typename TypeMap::
-        template Map<_idx>::Type*>(data); 
+        template Map<_idx>::Type*>(data);
     }
 
@@ -414,5 +414,5 @@
       LEMON_DEBUG(_idx == flag, "Variant wrong index");
       return *reinterpret_cast<typename TypeMap::template Map<_idx>::Type*>
-        (data); 
+        (data);
     }
 
@@ -425,5 +425,5 @@
 
   private:
-    
+
     char data[_variant_bits::Size<num - 1, TypeMap>::value];
     int flag;
@@ -443,5 +443,5 @@
 
     struct List {};
-    
+
     template <typename _Type, typename _List>
     struct Insert {
@@ -450,5 +450,5 @@
     };
 
-    template <int _idx, typename _T0, typename _T1, typename _T2, 
+    template <int _idx, typename _T0, typename _T1, typename _T2,
               typename _T3, typename _T5, typename _T4, typename _T6,
               typename _T7, typename _T8, typename _T9>
@@ -467,5 +467,5 @@
       typedef typename Get<_idx, L0>::Type Type;
     };
-    
+
   }
 
@@ -476,5 +476,5 @@
   /// \see Variant
   template <
-    typename _T0, 
+    typename _T0,
     typename _T1 = void, typename _T2 = void, typename _T3 = void,
     typename _T5 = void, typename _T4 = void, typename _T6 = void,
@@ -488,5 +488,5 @@
     };
   };
-  
+
 }
 